controllers/PostController.php
<?php

namespace app\controllers;

use app\models\PostNotifications;
use app\models\Posts;
use app\models\PostsSearch;
use Yii;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\web\Controller;
use yii\web\NotFoundHttpException;

/**
 * PostController implements the CRUD actions for Posts model.
 */
class PostController extends Controller
{
    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['view'],
                        'allow' => true,
                        'roles' => ['viewPost'],
                    ],
                    [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['updatePost'],
                        'roleParams' => ['postId' => Yii::$app->request->get('id')],
                    ],
                    [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['createPost'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['deletePost'],
                        'roleParams' => ['postId' => Yii::$app->request->get('id')],
                    ],
                    [
                        'actions' => ['index'],
                        'allow' => true,
                        'roles' => ['createPost'],
                    ],
                    [
                        'actions' => ['toggle-active'],
                        'allow' => true,
                        'roles' => ['updatePost'],
                        'roleParams' => ['postId' => Yii::$app->request->get('id')],
                    ],
                    [
                        'actions' => ['set-read'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Posts models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new PostsSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Posts model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Posts model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Posts();
        $model->user_id = Yii::$app->user->id;

        if (Yii::$app->request->isAjax) {
            return $this->renderAjax('_form', [
                'model' => $model
            ]);
        }

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing Posts model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if (Yii::$app->request->isAjax) {
            return $this->renderAjax('_form', [
                'model' => $model
            ]);
        }

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing Posts model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    public function actionSetRead($id)
    {
        $notification = PostNotifications::findOne(['post_id' => $id, 'user_id' => Yii::$app->user->id]);
        if (!is_null($notification)) {
            $notification->is_read = 1;
            $notification->save();
        }
    }

    public function actionToggleActive($id)
    {
        $post = $this->findModel($id);
        if (!is_null($post)) {
            $post->is_active = !$post->is_active;
            $post->save();
        }
        return $post->is_active;
    }

    /**
     * Finds the Posts model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Posts the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Posts::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}

controllers/UserController.php
<?php

namespace app\controllers;

use app\models\forms\NewPasswordForm;
use app\models\forms\ResetPasswordForm;
use app\models\User;
use app\models\UsersSearch;
use Yii;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\web\Controller;
use yii\web\NotFoundHttpException;

/**
 * UserController implements the CRUD actions for User model.
 */
class UserController extends Controller
{
    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' => true,
                        'roles' => ['administration'],
                    ],
                    [
                        'actions' => ['profile'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                    [
                        'actions' => ['registration', 'reset-password', 'registration-validate'],
                        'allow' => true,
                        'roles' => ['?'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all User models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new UsersSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single User model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new User model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new User();

        $model->setScenario(User::SCENARIO_CREATE);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {

            if (Yii::$app->request->isAjax) {
                return $this->renderAjax('_form', [
                    'model' => $model
                ]);
            }

            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing User model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        $model->setScenario(User::SCENARIO_UPDATE);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {

            if (Yii::$app->request->isAjax) {
                return $this->renderAjax('_form', [
                    'model' => $model
                ]);
            }

            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing User model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    public function actionToggleActive($id)
    {
        $model = $this->findModel($id);
        if (!is_null($model)) {
            $model->is_active = !$model->is_active;
            $model->save();
        }
        return $model->is_active;
    }

    /**
     * Настройка пользователя
     */
    public function actionProfile()
    {
        $model = $this->findModel(Yii::$app->user->id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            Yii::$app->session->addFlash('success', 'Настройки сохранены');
        }
        return $this->render('profile', [
            'model' => $model,
        ]);
    }

    public function actionResetPassword($id = null, $code = null)
    {
        $model = new ResetPasswordForm();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $model->user->sendResetPassword();
            Yii::$app->session->addFlash('success', 'Мы выслали вам ссылку для сбора пароля, на почту указанную при регистрации');
            return $this->redirect(['/']);
        }

        if (!empty($id) && !empty($code)) {
            $user = User::findOne($id);
            if ($user->password_reset_code == $code) {
                $model = new NewPasswordForm();

                if ($model->load(Yii::$app->request->post()) && $model->validate()) {
                    $user->updatePassword($model->password);
                    Yii::$app->session->addFlash('success', 'Пароль изменен');
                    return $this->redirect(['/']);
                }

                return $this->render('new-password', ['model' => $model]);
            } else {
                Yii::$app->session->addFlash('danger', 'Ссылка для восстановления пароля - не корректна');
            }
        }

        return $this->render('reset-password', ['model' => $model]);
    }

    public function actionRegistrationValidate($id, $code)
    {
        $user = User::findOne(['id' => $id]);

        if (is_null($user)) {
            throw new NotFoundHttpException('Такой пользователь не найден');
        }

        $user->setScenario(User::SCENARIO_VALIDATION);

        if ($user->getRegistrationCode() !== $code) {
            Yii::$app->session->addFlash('danger', 'не корректный код активации');
        } else {
            $user->is_active = 1;
            $user->is_validated = 1;
            if ($user->save()) {
                Yii::$app->session->addFlash('success', 'Спасибо за регистрацию, ваш E-Mail подтвержден');
            } else {
                Yii::$app->session->addFlash('danger', 'Не удалось активировать УЗ');
            }
        }

        return $this->redirect(['/site/login']);
    }

    public function actionRegistration()
    {
        $user = new User();
        $user->setScenario(User::SCENARIO_REGISTRATION);

        if ($user->load(Yii::$app->request->post()) && $user->save()) {
            Yii::$app->session->addFlash('success', 'Проверьте почту, мы выслали вам ссылку для подтверждения регистрации, перейдите по ней.');
        }

        return $this->render('registration', ['user' => $user]);
    }

    /**
     * Finds the User model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return User the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = User::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */

/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use app\widgets\Notifications;
use yii\bootstrap\Nav;
use yii\bootstrap\NavBar;
use yii\helpers\Html;
use yii\widgets\Breadcrumbs;

if (empty($this->title)) {
    $this->title = Yii::$app->name;
}

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <?= Html::csrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body>
<?php $this->beginBody() ?>

<div class="wrap">
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar-inverse navbar-fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav navbar-right'],
        'items' => [
            ['label' => 'Главная', 'url' => ['/site/index']],
            [
                'label' => 'Управление',
                'visible' => Yii::$app->user->can('administration') || Yii::$app->user->can('createPost'),
                'items' => [
                    ['label' => 'Новости', 'url' => ['/post/index'], 'visible' => Yii::$app->user->can('createPost')],
                    ['label' => 'Пользователи', 'url' => ['/user/index'], 'visible' => Yii::$app->user->can('administration')],
                ]
            ],
//            ['label' => 'О нас', 'url' => ['/site/about']],
//            ['label' => 'Контакты', 'url' => ['/site/contact']],
            Yii::$app->user->isGuest ? (
            ['label' => 'Войти', 'url' => ['/site/login']]
            ) : [
                'label' => Yii::$app->user->identity->login,
                'items' => [
                    ['label' => 'Профиль', 'url' => ['/user/profile']],
                    ['label' => 'Выйти (' . Yii::$app->user->identity->login . ')', 'url' => ['/site/logout']],
                ]
            ]
        ],
    ]);
    NavBar::end();
    ?>

    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>

        <?= Alert::widget() ?>
        <?= Notifications::widget() ?>

        <?= $content ?>
    </div>

    <div id="default-dialog" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="gridSystemModalLabel">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span
                                aria-hidden="true">&times;</span></button>
                    <h4 class="modal-title" id="gridSystemModalLabel">Modal title</h4>
                </div>
                <div class="modal-body"></div>
            </div><!-- /.modal-content -->
        </div><!-- /.modal-dialog -->
    </div><!-- /.modal -->

</div>

<footer class="footer">
    <div class="container">
        <p class="pull-left">&copy; My Company <?= date('Y') ?></p>

        <p class="pull-right"><?= Yii::powered() ?></p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>